PLaSK library

Loading...
Searching...
No Matches
Public Member Functions | Protected Attributes | List of all members
plask::optical::modal::LevelsAdapterRectangular< dim >::Mesh Struct Reference

`#include <solvers/optical/modal/meshadapter.hpp>`

Inheritance diagram for plask::optical::modal::LevelsAdapterRectangular< dim >::Mesh:
[legend]
Collaboration diagram for plask::optical::modal::LevelsAdapterRectangular< dim >::Mesh:
[legend]

## Public Member Functions
| Mesh (const RectangularLevel *level)
| Create mesh adapter.
std::size_t | size () const override
plask::Vec< dim > | at (std::size_t i) const override
| Get point with given mesh index.
std::size_t | size () const
plask::Vec< 2 > | at (std::size_t i) const
| Get point with given mesh index.
std::size_t | size () const
plask::Vec< 3 > | at (std::size_t i) const
| Get point with given mesh index.
Public Member Functions inherited from plask::MeshD< dim >
LocalCoords | operator[] (std::size_t index) const
| Get point with given mesh index.
const_iterator | begin () const
const_iterator | end () const
| MeshD (const MeshD &PLASK_UNUSED(to_copy))
| Initialize this to be the same as `to_copy` but don't copy any changes observer.
| MeshD ()
MeshD & | operator= (const MeshD &PLASK_UNUSED(to_copy))
| Set this to be the same as `to_copy` but doesn't changed changes observer.
bool | operator== (const MeshD &to_compare) const
| Check if this mesh and `to_compare` represent the same sequence of points (have exactly the same points in the same order).
bool | operator!= (const MeshD &to_compare) const
| Check if this mesh and `to_compare` represent different sequences of points.
void | print (std::ostream &out) const override
| Print this to stream `out`.
Public Member Functions inherited from plask::Mesh
template<typename ClassT , typename methodT >
boost::signals2::connection | changedConnectMethod (ClassT *obj, methodT method, boost::signals2::connect_position at=boost::signals2::at_back)
| Connect a method to changed signal.
template<typename ClassT , typename methodT >
void | changedDisconnectMethod (ClassT *obj, methodT method)
template<typename EventT = Event, typename ... Args>
void | fireChanged (Args &&... event_constructor_params_without_source)
| Call changed with this as event source.
void | fireResized ()
| This method is called when the mesh is resized.
virtual bool | empty () const
virtual void | writeXML (XMLElement &object) const
| Write mesh to XML.
virtual | ~Mesh ()
Public Member Functions inherited from plask::Printable
virtual | ~Printable ()
std::string | str () const
| Get string representation of this using print method.
Public Member Functions inherited from plask::MeshBase
virtual | ~MeshBase ()

## Protected Attributes
const RectangularLevel * | level

## Additional Inherited Members
Public Types inherited from plask::MeshD< dim >
enum |
| Number of dimensions. More...
typedef Primitive< DIM >::DVec | LocalCoords
| Type of vector representing coordinates in local space.
typedef IndexedIterator< const MeshD< dimension >, LocalCoords > | const_iterator
| Random access iterator type which allow iterate over all points in this mesh, in order appointed by operator[].
typedef const_iterator | iterator
typedef const_iterator | Iterator
Public Attributes inherited from plask::Mesh
boost::signals2::signal< void(Event &)> | changed
| Changed signal, fired when mesh was changed.
Protected Member Functions inherited from plask::MeshD< dim >
virtual bool | hasSameNodes (const MeshD< dimension > &to_compare) const
| Check if this mesh and `to_compare` represent the same sequence of points (have exactly the same points in the same order).
Protected Member Functions inherited from plask::Mesh
virtual void | onChange (const Event &evt)
| This method is called when the mesh is changed, just before changed signal.

## Detailed Description

template<int dim>
struct plask::optical::modal::LevelsAdapterRectangular< dim >::Mesh

Definition at line 122 of file meshadapter.hpp.

## Constructor & Destructor Documentation

## ◆ Mesh()

template<int dim>

plask::optical::modal::LevelsAdapterRectangular< dim >::Mesh::Mesh | ( | const RectangularLevel * | level | ) |
| inline

Create mesh adapter.

Definition at line 127 of file meshadapter.hpp.

## Member Function Documentation

## ◆ at() [1/3]

plask::Vec< 2 > plask::optical::modal::LevelsAdapterRectangular::Mesh< 2 >::at | ( | std::size_t | index | ) | const
| virtual

Get point with given mesh index.

Parameters

  index | index of point, from 0 to size()-1

Returns
  point with given `index`

Implements plask::MeshD< dim >.

Definition at line 43 of file meshadapter.cpp.

## ◆ at() [2/3]

plask::Vec< 3 > plask::optical::modal::LevelsAdapterRectangular::Mesh< 3 >::at | ( | std::size_t | index | ) | const
| virtual

Get point with given mesh index.

Parameters

  index | index of point, from 0 to size()-1

Returns
  point with given `index`

Implements plask::MeshD< dim >.

Definition at line 63 of file meshadapter.cpp.

## ◆ at() [3/3]

template<int dim>

plask::Vec< dim > plask::optical::modal::LevelsAdapterRectangular< dim >::Mesh::at | ( | std::size_t | index | ) | const
| override virtual

Get point with given mesh index.

Parameters

  index | index of point, from 0 to size()-1

Returns
  point with given `index`

Implements plask::MeshD< dim >.

## ◆ size() [1/3]

std::size_t plask::optical::modal::LevelsAdapterRectangular::Mesh< 2 >::size | ( |  | ) | const
| virtual

Returns
  number of points in mesh

Implements plask::Mesh.

Definition at line 39 of file meshadapter.cpp.

## ◆ size() [2/3]

std::size_t plask::optical::modal::LevelsAdapterRectangular::Mesh< 3 >::size | ( |  | ) | const
| virtual

Returns
  number of points in mesh

Implements plask::Mesh.

Definition at line 59 of file meshadapter.cpp.

## ◆ size() [3/3]

template<int dim>

std::size_t plask::optical::modal::LevelsAdapterRectangular< dim >::Mesh::size | ( |  | ) | const
| override virtual

Returns
  number of points in mesh

Implements plask::Mesh.

## Member Data Documentation

## ◆ level

template<int dim>

const RectangularLevel* plask::optical::modal::LevelsAdapterRectangular< dim >::Mesh::level
| protected

Definition at line 124 of file meshadapter.hpp.

The documentation for this struct was generated from the following file:

- solvers/optical/modal/meshadapter.hpp